﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DSO_CSharp
{	
	public partial class Form1 : Form
	{
		DSOSDK_Class cDsoClass = new DSOSDK_Class();
		int iRecLength = 50000; 		

		public Form1()
		{
			InitializeComponent();
		}

		private void bnConnect_Click(object sender, EventArgs e)
		{
			if (cDsoClass.uDsoSDKInit() == 0)
				MessageBox.Show("Init Fail");
			else
			{
				StringBuilder strProductName = new StringBuilder(32);
				StringBuilder strSerialNum = new StringBuilder(32);
				cDsoClass.uDsoSDKGetProductName(0, strProductName);
				cDsoClass.uDsoSDKGetSerialNum(0, strSerialNum);
				MessageBox.Show(strProductName.ToString() + "\r\nID = " + strSerialNum);
			}
		}

		private void bnCapture_Click(object sender, EventArgs e)
		{
			cDsoClass.uDsoSDKReadIniFile("DSO.ini");
			cDsoClass.uDsoSDKCaptureEx();
			while (!cDsoClass.uDsoSDKDataReady()) ;
		}

		private void bnMeas_Click(object sender, EventArgs e)
		{
			int iDevice = 0;
			int iFlag = 0;
			
			int iVoltDiv = 500000;	//500mV
			int iTrigOfs = 0;
			int iProbe = 10;
			Int64 i64ScData = 1000000;
			double[] dYOfsA = new double[2];
			double[] dYOfsB = new double[2];
			double[] dYMul = new double[2];
			double[] dVOfs = new double[2];
			short[] lpwWaveDataA = new short[iRecLength];
			short[] lpwWaveDataB = new short[iRecLength];

			short[] sReadBuf = new short[iRecLength * 2];	//2 device

			cDsoClass.uDsoSDKReadExRaw(iDevice, ref iFlag, sReadBuf, dYOfsA, dYOfsB, dYMul, ref iTrigOfs);
			for (int i = 0; i < iRecLength; i ++)
			{
				lpwWaveDataA[i] = sReadBuf[i];
				lpwWaveDataB[i] = sReadBuf[i + iRecLength];
			}
			

			bool fForceStop = false;
			int iStart = 0;
			int iEnd = iRecLength;
			bool fResult = true;
			//Set Captured Waveform Information
			fResult &= cDsoClass.uDsoSDKMeasExInit(0, iVoltDiv, dVOfs[0], dYOfsA[0], dYOfsB[0], dYMul[0], iProbe, i64ScData, iRecLength, lpwWaveDataA);
			fResult &= cDsoClass.uDsoSDKMeasExInit(1, iVoltDiv, dVOfs[1], dYOfsA[1], dYOfsB[1], dYMul[1], iProbe, i64ScData, iRecLength, lpwWaveDataB);

			//Add Measurement type
			fResult &= cDsoClass.uDsoSDKMeasExAddType(0);
			fResult &= cDsoClass.uDsoSDKMeasExAddType(9);

			fResult &= cDsoClass.uDsoSDKMeasExStart(iStart, iEnd, ref fForceStop);

			if (!fResult)
			{
				MessageBox.Show("Meas Error!");
				return;
			}

			string str = "";

			if (cDsoClass.uDsoSDKMeasExGetResult(0))
				str += cDsoClass.uDsoSDKMeasExGetValue(0).ToString() + "\n";
			else			
				str += "fail\n";
			
			if (cDsoClass.uDsoSDKMeasExGetResult(9))
				str += cDsoClass.uDsoSDKMeasExGetValue(9).ToString() + "\n";
			else
				str += "fail\n";
			
			
			if (str.Length != 0)
				MessageBox.Show(str);

			cDsoClass.uDsoSDKMeasExFreeResource();
		}

		private void bnDisconnect_Click(object sender, EventArgs e)
		{
			cDsoClass.uDsoSDKShutdown();
		}
	}
}
